// This program uses the bubble sort algorithm to sort an
// array in ascending order.
#include <iostream>
using namespace std;

// Function prototypes
void bubbleSort(int [], int);
void showArray(int [], int);

int main()
{
	// Array of unsorted values
	int values[6] = {7, 2, 3, 8, 9, 1};

	// Display the values.
	cout << "The unsorted values are:\n";
	showArray(values, 6);

	// Sort the values.
	bubbleSort(values, 6);

	// Display them again.
	cout << "The sorted values are:\n";
	showArray(values, 6);
	return 0;
}

//***********************************************************
// Definition of function bubbleSort                         *
// This function performs an ascending order bubble sort on *
// array. size is the number of elements in the array.     *
//***********************************************************

void bubbleSort(int array[], int size) {
	bool swap;
	int temp, test, lastUnsorted;

	lastUnsorted = size-1;
	do {
		swap = false;
		for (test = 0; test < lastUnsorted; test++) {
			if (array[test] > array[test + 1]) {
				temp = array[test];
				array[test] = array[test + 1];
				array[test + 1] = temp;
				swap = true;
			} // end if
		} // end for
		lastUnsorted--;
	} while (swap);
} // end sortArray

//*************************************************************
// Definition of function showArray.                          *
// This function displays the contents of array. size is the *
// number of elements.                                        *
//*************************************************************

void showArray(int array[], int size)
{
	for (int count = 0; count < size; count++)
		cout << array[count] << " ";
	cout << endl;
}


