// This program uses the selection sort algorithm to sort an
// array in ascending order.
#include <iostream>
using namespace std;

// Function prototypes
void selectionSort(int [], int);
void showArray(int [], int);

int main()
{
	// Array of unsorted values
	int values[6] = {7, 2, 3, 8, 9, 1};

	// Display the values.
	cout << "The unsorted values are:\n";
	showArray(values, 6);

	// Sort the values.
	selectionSort(values, 6);

	// Display them again.
	cout << "The sorted values are:\n";
	showArray(values, 6);
	return 0;
}

//***********************************************************
// Definition of template function selectionSort            *
// This function performs an ascending order selection sort *
// on array. size is the number of elements in the array.   *
//***********************************************************

void selectionSort(int array[], int size) {
	int temp, testIndex, minIndex, firstUnsortedIndex;

	for (firstUnsortedIndex = 0; firstUnsortedIndex < size-1; firstUnsortedIndex++) {
		minIndex = firstUnsortedIndex;
		for (testIndex = firstUnsortedIndex+1; testIndex < size; testIndex++) {
			if (array[testIndex] < array[minIndex]) {
				minIndex = testIndex;
			} // end if
		} // end for
		temp = array[firstUnsortedIndex];
		array[firstUnsortedIndex] = array[minIndex];
		array[minIndex] = temp;
	} // end for
} // end selectionSort

//*************************************************************
// Definition of function showArray.                          *
// This function displays the contents of array. size is the *
// number of elements.                                        *
//*************************************************************

void showArray(int array[], int size)
{
	for (int count = 0; count < size; count++)
		cout << array[count] << " ";
	cout << endl;
}


